/*******************************************************************************
 * AnimNotify_Trails generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class AnimNotify_Trails extends AnimNotify
    native(Anim)
    editinlinenew
    collapsecategories
    hidecategories(Object);

struct native TrailSocketSamplePoint
{
    var Vector Position;
    var Vector Velocity;

    structdefaultproperties
    {
        Position=(X=0.0,Y=0.0,Z=0.0)
        Velocity=(X=0.0,Y=0.0,Z=0.0)
    }
};

struct native TrailSamplePoint
{
    var float RelativeTime;
    var TrailSocketSamplePoint FirstEdgeSample;
    var TrailSocketSamplePoint ControlPointSample;
    var TrailSocketSamplePoint SecondEdgeSample;

    structdefaultproperties
    {
        RelativeTime=0.0
        FirstEdgeSample=(Position=(X=0.0,Y=0.0,Z=0.0),Velocity=(X=0.0,Y=0.0,Z=0.0))
        ControlPointSample=(Position=(X=0.0,Y=0.0,Z=0.0),Velocity=(X=0.0,Y=0.0,Z=0.0))
        SecondEdgeSample=(Position=(X=0.0,Y=0.0,Z=0.0),Velocity=(X=0.0,Y=0.0,Z=0.0))
    }
};

struct native TrailSample
{
    var float RelativeTime;
    var Vector FirstEdgeSample;
    var Vector ControlPointSample;
    var Vector SecondEdgeSample;

    structdefaultproperties
    {
        RelativeTime=0.0
        FirstEdgeSample=(X=0.0,Y=0.0,Z=0.0)
        ControlPointSample=(X=0.0,Y=0.0,Z=0.0)
        SecondEdgeSample=(X=0.0,Y=0.0,Z=0.0)
    }
};

var(Trails) ParticleSystem PSTemplate;
var(Trails) editoronly editconst SkeletalMesh SampledSkeletalMesh;
var(Trails) bool bIsExtremeContent;
var() editoronly bool bPreview;
var() editoronly bool bPreviewForceExplicit;
var() bool bSkipIfOwnerIsHidden;
var bool bResampleRequired;
var(Trails) name FirstEdgeSocketName;
var(Trails) name ControlPointSocketName;
var(Trails) name SecondEdgeSocketName;
var float LastStartTime;
var float EndTime;
var deprecated float SampleTimeStep;
var deprecated array<deprecated TrailSamplePoint> TrailSampleData;
var(Trails) float SamplesPerSecond;
var array<TrailSample> TrailSampledData;
var transient float CurrentTime;
var transient float TimeStep;
var transient AnimNodeSequence AnimNodeSeq;

// Export UAnimNotify_Trails::execGetNumSteps(FFrame&, void* const)
native function int GetNumSteps(int InLastTrailIndex);

defaultproperties
{
    bSkipIfOwnerIsHidden=true
    FirstEdgeSocketName=EndControl
    ControlPointSocketName=MidControl
    SecondEdgeSocketName=StartControl
    SamplesPerSecond=60.0
}